%LAB 19/12/2012 N.1
%
%Simone Milani
%
%progetto di filtri FIR con finestre differenti
%
%Si vuole progettare un filtro FIR passa banda con banda passante
%centrata in F0=.12 e larghezza di banda Bw=.8 (in freq. normalizzate con
%convenzione MATLAB). La banda di transizione è .02.
%
%Il progetto utilizza finestre e metodi di stima di tipo diverso 


close all; clear all; %pulisce

%segnale da filtrare
load segnale;


%parametri costruttivi del filtro
Bw=0.08 %larghezza di banda (freq positive)
F0=0.12; %freq centrale
Bt=0.02; %banda di transizione
F1=F0-Bw/2;
F2=F0+Bw/2;
F02=F2+Bt;
F01=F1-Bt;

%array di valori per progetto con firpm
w1=[0 F01 F1 F2 F02  1];
A1=[ 0.05 0.05 1 1 0.05 0.05];

%numero di coefficienti -1
N1=40;

%standard
h1=fir1(N1,[F1 F2]); %progetto
yf1=filter(h1,1,y); %filtraggio

%finestra kaiser
h2=fir1(N1,[F1 F2],kaiser(N1+1,4)); %progetto
yf2=filter(h2,1,y); %filtraggio

%finestra chebychev
h3=fir1(N1,[F1 F2],chebwin(N1+1,26)); %progetto
yf3=filter(h3,1,y); %filtraggio

%finestra taylor
h4=fir1(N1,[F1 F2],taylorwin(N1+1)); %progetto
yf4=filter(h4,1,y); %filtraggio

%hanning
h5=fir1(N1,[F1 F2],hamming(N1+1)); %progetto
yf5=filter(h5,1,y); %filtraggio

%hanning
h6=fir1(N1,[F1 F2],hanning(N1+1)); %progetto
yf6=filter(h6,1,y); %filtraggio

%visualizza i filtri
fdisp=fvtool(h1,1,h2,1,h3,1,h4,1,h5,1,h6,1);
legend(fdisp,'rect','kaiser','cheb','taylor','hamming','hanning');
zoom(fdisp,'x',[0 .4 ]);

pause;

%metodi di realizzazione diversi

%campionamento in freq
h7=fir2(N1,w1,A1); %progetto
yf7=filter(h7,1,y); %filtraggio


%least square
h8=firls(N1,w1,A1); %progetto
yf8=filter(h8,1,y); %filtraggio

%visualizza
fdisp=fvtool(h1,1,h7,1,h8,1);
legend(fdisp='win','fsamp','ls');
zoom(fdisp,'x',[0 .4 ]);


