%LAB 19/12/2012 N.2
%
%Simone Milani
%
%progetto di filtri IIR per filtraggio passa banda
%
%Dato il segnale in ingresso (riferito ambiente sonoro naturale = ruscello)
%si vuole selezionare la traccia sonora relativa ad un particolare animale 
%(in questo caso il cuculo). Si sa che il verso/canto dell'animale ha uno
%spettro in frequenza centrato attorno a F0=.12 e di larghezza Bw=.8 (in freq. normalizzate con
%convenzione MATLAB).
%Si vuole progettare un filtro IIR passa banda con banda di transizione è .02.
%Il filtro viene confrontato con un possibile equivalente FIR.
%
%Nel progetto vengono utilizzate classi di filtri diverse.
%E' possibile verificare sia visivamente (tramite la risposta in freq) che
%uditivamente l'efficienza dei vari filtri (usando il comando sound(y,Fs)).

close all; clear all; %pulisco

%carico il segnale in y con freq di campionamento Fs
load segnale;

%caratteristiche dello spettro per
%l'animale cuckoo e
%parametri costruttivi del filtro
Bw=0.08 %larghezza di banda (freq positive)
F0=0.12; %freq centrale
Bt=0.02; %banda di transizione
F1=F0-Bw/2;
F2=F0+Bw/2;
F02=F2+Bt;
F01=F1-Bt;



%vettori per costruzione via firpm
w1=[0 F01 F1 F2 F02  1];
A1=[ 0.05 0.05 1 1 0.05 0.05];

%FIR
%valori dei ripple per firpm
rip_vet=[0.01 0.02 0.01];
Aord=[0 1 0];
%calcolo ordine e parametri del FIR
[N1,Fo,Ao,Wo]=firpmord(w1(2:5),Aord,rip_vet,2);
%progetto del FIR
h1=firpm(N1+1,w1,A1);
%filtraggio
yf1=filter(h1,1,y); %yf1: segnale filtrato con FIR

%CHEBYSHEV tipo 1
%calcolo ordine
[N2, Wp2] = cheb1ord([F1 F2], [ F01 F02], 0.01, 20);
%progetto
[b2,a2]=cheby1(N2,0.1,Wp2);
%calcolo anche zeri poli e guadagno
[z2,p2,k2]=cheby1(N2,0.1,Wp2);
%filtraggio
yf2=filter(b2,a2,y); %yf2: segnale filtrato con Chebyshev

%ELLITTICO
%calcolo ordine
[N3, Wp3] = ellipord([F1 F2], [ F01 F02], 0.01, 20);
%progetto
[b3,a3]=ellip(N3,0.1,20,Wp3);
%calcolo zeri e poli del filtro
[z3,p3,k3]=ellip(N3,0.1,20,Wp3);
%filtraggio
yf3=filter(b3,a3,y); %yf3: segnale filtrato con filtro ell


%visualizzo le risposte in freq
fdisp=fvtool(h1,1,b2,a2,b3,a3);
legend(fdisp,'firpm','cheb1','ell');
ylim([-100 2]);
zoom(fdisp,'x',[0 .6]);

%ascolto il risultato
disp('Segnale originale');
sound(y,Fs);
disp('Premi invio per continuare');
pause;
disp('Segnale filtrato FIR');
sound(yf1,Fs);
disp('Premi invio per continuare');
pause;
disp('Segnale filtrato IIR Chebyshev');
sound(yf2,Fs);
disp('Premi invio per continuare');
pause;
disp('Segnale filtrato IIR ellittico');
sound(yf3,Fs);


%E' possibile rilevare e sentire che chebyshev è quello + efficiente in
%quanto isola il segnale desiderato in modo efficiente.
%Nei segnali ottenuti da altri filtri sono presenti altri animali:
